%{!?tcl_version: %define tcl_version %(echo 'puts $tcl_version' | tclsh)}
%{!?tcl_sitelib: %define tcl_sitelib %{_datadir}/tcl%{tcl_version}}
%define cvsdate 20061030

Summary: Development and debugging tools for Tcl applications
Name: tclpro
Version: 1.5.0
Release: 11.%{cvsdate}cvs%{?dist}
License: TCL
Group: Development/Tools
# cvs -d:pserver:anonymous@tclpro.cvs.sourceforge.net:/cvsroot/tclpro export -D 2006-10-30 -d tclpro-20061030cvs tbcload
# tar czf tclpro-20061030cvs.tgz ./tclpro-20061030cvs
Source0: tclpro-%{cvsdate}cvs.tgz
Source1: tclpro.desktop
Source2: prodebug.png
Source3: procomp_pkgIndex.tcl
Patch0: tclpro-projectInfo.patch
Patch1: tclpro-checker-startup.patch
Patch2: tclpro-compiler-startup.patch
Patch3: tclpro-compiler-package.patch
Patch4: tclpro-1.5.0-tclm4cvs.patch
Patch5: tclpro-1.5.0-about.patch
Patch6: tclpro-1.5.0-helpurl.patch
URL: http://tclpro.sourceforge.net/
Requires: tcl(abi) = 8.5 tk >= 0:8.3.2 tcllib tclcompiler tcldebugger tclchecker
BuildRequires: tcl-devel autoconf
BuildRequires: desktop-file-utils
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch

%description
The TclPro tool set includes a graphical debugger, a static code checker,
a compiler that writes out Tcl byte codes, and a loader that reads
byte codes.

%prep
%setup -q -n %{name}-%{cvsdate}cvs
%patch0 -p0
%patch1 -p0
%patch2 -p1
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0

for i in debugger checker projectInfo compiler ; do 
    pushd modules/$i
    autoconf
    popd
done

%build
pushd modules/projectInfo
%configure --libdir=%{tcl_sitelib} --datadir=%{tcl_sitelib}
make %{?_smp_mflags}
popd

%install
rm -rf $RPM_BUILD_ROOT
pushd modules/projectInfo
make install DESTDIR=$RPM_BUILD_ROOT
popd
mkdir -p $RPM_BUILD_ROOT%{_bindir}
sed -e 's#@imagedir@#%{tcl_sitelib}/tcldebugger1.4#' < modules/debugger/src/startup.tcl > $RPM_BUILD_ROOT/%{_bindir}/prodebug
chmod 755 $RPM_BUILD_ROOT/%{_bindir}/prodebug
install -m 755 modules/checker/src/startup.tcl $RPM_BUILD_ROOT/%{_bindir}/procheck
install -m 755 modules/compiler/src/startup.tcl $RPM_BUILD_ROOT/%{_bindir}/procompile

# The Tcl compiler application needs an extra file/package to run.
mkdir -p $RPM_BUILD_ROOT%{tcl_sitelib}/procomp1.5
install -m 644 modules/compiler/src/procomp.tcl $RPM_BUILD_ROOT/%{tcl_sitelib}/procomp1.5/
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT/%{tcl_sitelib}/procomp1.5/pkgIndex.tcl

# Fix a few file permissions for rpmlint
chmod a-x $RPM_BUILD_ROOT%{tcl_sitelib}/projectInfo1.4/*.tcl


desktop-file-install --vendor fedora                            \
        --dir ${RPM_BUILD_ROOT}%{_datadir}/applications         \
        %{SOURCE1}
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/pixmaps/
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/%{_datadir}/pixmaps/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc ChangeLog
%defattr(-,root,root)
%{_bindir}/procheck
%{_bindir}/prodebug
%{_bindir}/procompile
%{tcl_sitelib}/procomp1.5
%{tcl_sitelib}/projectInfo1.4
%{_datadir}/applications/fedora-tclpro.desktop
%{_datadir}/pixmaps/prodebug.png

%changelog
* Thu Jan 13 2008 Wart <wart at kobold.org> 1.5.0-11.20061030cvs
- Rebuild for Tcl 8.5

* Sat Dec 15 2007 Wart <wart at kobold.org> 1.5.0-10.20061030cvs
- Fix startup bug with procompile (BZ #425807)

* Tue Aug 21 2007 Wart <wart at kobold.org> 1.5.0-9.20061030cvs
- License tag clarification

* Sat Aug 11 2007 Wart <wart at kobold.org> 1.5.0-8.20061030cvs
- Use correct version in .desktop file
- Clean up .desktop file categories

* Sat Jun 2 2007 Wart <wart at kobold.org> 1.5.0-7.20061030cvs
- Move to a tcl-specific directory for faster loading

* Tue Oct 31 2006 Wart <wart at kobold.org> 1.5.0-6.20061030cvs
- Initial package for Fedora

* Mon Jul 10 2006 Wart <wart at kobold.org> 1.5.0-5.1
- Clean up a few rpmlint warnings

* Tue Mar 28 2006 Wart <wart at kobold.org> 1.5.0-5
- Update tcl.m4 to fix quoting bug exposed in Fedora Core 5

* Mon Dec 5 2005 Wart <wart at kobold.org> 1.5.0-3
- Replace older tk* commands with proper tk::* namespaced commands.

* Mon Nov 28 2005 Wart <wart at kobold.org> 1.5.0-2
- Added the TclPro compiler.

* Sun Nov 27 2005 Wart <wart at kobold.org> 1.5.0-1
- Initial spec file.
